diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/ns3 ns-3.38/ns3
--- ns-3.37/ns3	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/ns3	2023-03-16 20:54:23.572868300 -0700
@@ -81,9 +81,16 @@
 def parse_args(argv):
     parser = argparse.ArgumentParser(description="ns-3 wrapper for the CMake build system", add_help=False)
 
+    sub_parser = parser.add_subparsers()
+
     parser.add_argument('-h', '--help',
                         help="Print a summary of available commands",
-                        action="store_true", default=None, dest="help")
+                        action="store_true", default=None, dest="main_help")
+    parser_help = sub_parser.add_parser('help',
+                                        help='Print a summary of available commands')
+    parser_help.add_argument('help',
+                             help='Print a summary of available commands',
+                             action="store_true", default=False)
     # parser.add_argument('--docset',
     #               help=(
     #                   'Create Docset, without building. This requires the docsetutil tool from Xcode 9.2 or earlier.'
@@ -91,8 +98,6 @@
     #               action="store_true", default=None,
     #               dest="docset_build")
 
-    sub_parser = parser.add_subparsers()
-
     parser_build = sub_parser.add_parser('build',
                                          help=('Accepts a list of targets to build,'
                                                ' or builds the entire project if no target is given'),
@@ -135,6 +140,7 @@
         ("build-version", "embedding git changes as a build version during build"),
         ("clang-tidy", "clang-tidy static analysis"),
         ("dpdk", "the fd-net-device DPDK features"),
+        ("eigen", "Eigen3 library support"),
         ("examples", "the ns-3 examples"),
         ("gcov", "code coverage analysis"),
         ("gsl", "GNU Scientific Library (GSL) features"),
@@ -142,6 +148,7 @@
         ("logs", "the logs regardless of the compile mode"),
         ("monolib", "a single shared library with all ns-3 modules"),
         ("mpi", "the MPI support for distributed simulation"),
+        ("ninja-tracing", "the conversion of the Ninja generator log file into about://tracing format"),
         ("precompiled-headers", "precompiled headers"),
         ("python-bindings", "python bindings"),
         ("tests", "the ns-3 tests"),
@@ -206,6 +213,9 @@
     parser_clean = sub_parser.add_parser('clean', help='Removes files created by ns3')
     parser_clean.add_argument('clean', action="store_true", default=False)
 
+    parser_distclean = sub_parser.add_parser('distclean', help='Removes files created by ns3, tests and documentation')
+    parser_distclean.add_argument('distclean', action="store_true", default=False)
+
     parser_install = sub_parser.add_parser('install', help='Install ns-3')
     parser_install.add_argument('install', action="store_true", default=False)
 
@@ -285,7 +295,7 @@
                              action="store", type=str, nargs="?", default="all")
 
     add_argument_to_subparsers(
-        [parser, parser_build, parser_configure, parser_clean, parser_docs, parser_run, parser_show],
+        [parser, parser_build, parser_configure, parser_clean, parser_distclean, parser_docs, parser_run, parser_show],
         ["--dry-run"],
         help_msg="Do not execute the commands.",
         dest="dry_run")
@@ -325,6 +335,15 @@
         parser_run.print_help()
         exit(-1)
 
+    # Merge attributes
+    attributes_to_merge = ["dry_run", "help", "verbose", "quiet"]
+    filtered_attributes = list(
+        filter(lambda x: x if ("disable" not in x and "enable" not in x) else None, args.__dir__()))
+    for attribute in attributes_to_merge:
+        merging_attributes = list(
+            map(lambda x: args.__getattribute__(x) if attribute in x else None, filtered_attributes))
+        setattr(args, attribute, merging_attributes.count(True) > 0)
+
     if args.help:
         print(parser.description)
         print("")
@@ -346,15 +365,6 @@
         print(parser.format_help().replace(parser.description, "").replace(parser.format_usage(), ""))
         exit(0)
 
-    # Merge attributes
-    attributes_to_merge = ["dry_run", "verbose", "quiet"]
-    filtered_attributes = list(
-        filter(lambda x: x if ("disable" not in x and "enable" not in x) else None, args.__dir__()))
-    for attribute in attributes_to_merge:
-        merging_attributes = list(
-            map(lambda x: args.__getattribute__(x) if attribute in x else None, filtered_attributes))
-        setattr(args, attribute, merging_attributes.count(True) > 0)
-
     attributes_to_merge = ["jobs"]
     filtered_attributes = list(filter(lambda x: x if ("disable" not in x and "enable" not in x) else 0, args.__dir__()))
     for attribute in attributes_to_merge:
@@ -363,7 +373,7 @@
         setattr(args, attribute, min(merging_attributes))
 
     # If some positional options are not in args, set them to false.
-    for option in ["clean", "configure", "docs", "install", "run", "shell", "uninstall", "show"]:
+    for option in ["clean", "configure", "docs", "install", "run", "shell", "uninstall", "show", "distclean"]:
         if option not in args:
             setattr(args, option, False)
 
@@ -417,28 +427,83 @@
     print_buffer += "\n" + message
 
 
+def remove_dir(dir_to_remove, dry_run, directory_qualifier=""):
+    dir_to_remove = os.path.abspath(dir_to_remove)
+    if os.path.exists(dir_to_remove):
+        if ".." in os.path.relpath(dir_to_remove, ns3_path):
+            # In case the directory to remove isn't within
+            # the current ns-3 directory, print an error
+            # message for the dry-run case
+            # Or throw an exception in a normal run
+            error_message = (f"The {directory_qualifier} directory '{dir_to_remove}' "
+                             "is not within the current ns-3 directory. "
+                             "Deleting it can cause data loss.")
+            if dry_run:
+                print_and_buffer(error_message)
+                return
+            else:
+                raise Exception(error_message)
+
+        # Remove directories that are within the current ns-3 directory
+        print_and_buffer("rm -R %s" % os.path.relpath(dir_to_remove, ns3_path))
+        if not dry_run:
+            shutil.rmtree(dir_to_remove, ignore_errors=True)
+
+
+def remove_file(file_to_remove, dry_run):
+    if os.path.exists(file_to_remove):
+        print_and_buffer("rm -R %s" % os.path.relpath(file_to_remove, ns3_path))
+        if not dry_run:
+            os.remove(file_to_remove)
+
+
 def clean_cmake_artifacts(dry_run=False):
-    print_and_buffer("rm -R %s" % os.path.relpath(out_dir, ns3_path))
-    if not dry_run:
-        if out_dir == ns3_path:
-            raise Exception("The output directory and the ns-3 directory are the same. "
-                            "Deleting it can cause data loss.")
-        shutil.rmtree(out_dir, ignore_errors=True)
+    remove_dir(out_dir, dry_run, "output")
 
     cmake_cache_files = glob.glob("%s/**/CMakeCache.txt" % ns3_path, recursive=True)
     for cmake_cache_file in cmake_cache_files:
         dirname = os.path.dirname(cmake_cache_file)
-        print_and_buffer("rm -R %s" % os.path.relpath(dirname, ns3_path))
-        if not dry_run:
-            if dirname == ns3_path:
-                raise Exception("The CMake cache directory and the ns-3 directory are the same. "
-                                "Deleting it can cause data loss.")
-            shutil.rmtree(dirname, ignore_errors=True)
+        remove_dir(dirname, dry_run, "CMake cache")
 
-    if os.path.exists(lock_file):
-        print_and_buffer("rm %s" % os.path.relpath(lock_file, ns3_path))
-        if not dry_run:
-            os.remove(lock_file)
+    dirs_to_remove = [os.path.join(ns3_path, "testpy-output"),
+                      os.path.join(ns3_path, "__pycache__")
+                      ]
+    for dir_to_remove in dirs_to_remove:
+        remove_dir(dir_to_remove, dry_run)
+
+    remove_file(lock_file, dry_run)
+
+
+def clean_docs_and_tests_artifacts(dry_run=False):
+    docs_dir = os.path.join(ns3_path, 'doc')
+
+    file_artifacts = ["doxygen.log",
+                      "doxygen.warnings.log",
+                      "introspected-command-line.h",
+                      "introspected-doxygen.h",
+                      "ns3-object.txt"]
+    docs_files = [os.path.join(docs_dir, filename) for filename in file_artifacts]
+
+    docs_and_tests_dirs = [os.path.join(docs_dir, "html"),
+                           os.path.join(docs_dir, "html-warn"),
+                           ]
+    docs_and_tests_dirs.extend(glob.glob(f"{docs_dir}/**/build", recursive=True))
+    docs_and_tests_dirs.extend(glob.glob(f"{docs_dir}/**/source-temp", recursive=True))
+
+    for directory in docs_and_tests_dirs:
+        remove_dir(directory, dry_run)
+
+    for file in docs_files:
+        remove_file(file, dry_run)
+
+
+def clean_pip_packaging_artifacts(dry_run=False):
+    pip_dirs = [os.path.join(ns3_path, "dist"),
+                os.path.join(ns3_path, "nsnam.egg-info"),
+                os.path.join(ns3_path, "wheelhouse")
+                ]
+    for directory in pip_dirs:
+        remove_dir(directory, dry_run)
 
 
 def search_cmake_cache(build_profile):
@@ -575,6 +640,7 @@
                ("COVERAGE", "gcov"),
                ("DES_METRICS", "des_metrics"),
                ("DPDK", "dpdk"),
+               ("EIGEN", "eigen"),
                ("ENABLE_BUILD_VERSION", "build_version"),
                ("ENABLE_SUDO", "sudo"),
                ("EXAMPLES", "examples"),
@@ -583,6 +649,7 @@
                ("LOG", "logs"),
                ("MONOLIB", "monolib"),
                ("MPI", "mpi"),
+               ("NINJA_TRACING", "ninja_tracing"),
                ("PRECOMPILE_HEADERS", "precompiled_headers"),
                ("PYTHON_BINDINGS", "python_bindings"),
                ("SANITIZE", "sanitizers"),
@@ -595,12 +662,17 @@
     for (cmake_flag, option_name) in options:
         arg = on_off_condition(args, cmake_flag, option_name)
         if arg:
+            is_on = "=ON" in arg
+            reverse = arg.replace("=ON" if is_on else "=OFF",
+                                  "=OFF" if is_on else "=ON")
+            if reverse in cmake_args:
+                cmake_args.remove(reverse)
             cmake_args.append(arg)
 
     if args.lcov_zerocounters is not None:
         cmake_args.append("-DNS3_COVERAGE_ZERO_COUNTERS=%s" % on_off(args.lcov_zerocounters))
 
-    # Output, Brite, Click and Openflow directories
+    # Output, Brite, Click and Openflow dirs
     if args.output_directory is not None:
         cmake_args.append("-DNS3_OUTPUT_DIRECTORY=%s" % args.output_directory)
 
@@ -667,7 +739,8 @@
 
 
 def refresh_cmake(current_cmake_cache_folder, output):
-    ret = subprocess.run([check_program_installed("cmake"), ".."], cwd=current_cmake_cache_folder, stdout=output)
+    cmake, _ = cmake_check_version()
+    ret = subprocess.run([cmake, ".."], cwd=current_cmake_cache_folder, stdout=output)
     if ret.returncode != 0:
         exit(ret.returncode)
     update_scratches_list(current_cmake_cache_folder)
@@ -768,7 +841,8 @@
 
 def cmake_check_version():
     # Check CMake version
-    cmake = shutil.which("cmake")
+    cmake3 = shutil.which("cmake3")
+    cmake = cmake3 if cmake3 else shutil.which("cmake")
     if not cmake:
         print("Error:  CMake not found; please install version 3.10 or greater, or modify", path_variable)
         exit(1)
@@ -781,12 +855,12 @@
 
 
 def cmake_build(current_cmake_cache_folder, output, jobs, target=None, dry_run=False, build_verbose=False):
-    _, version = cmake_check_version()
+    cmake, version = cmake_check_version()
 
     # Older CMake versions don't accept the number of jobs directly
     jobs_part = ("-j %d" % jobs) if parse_version(version) >= parse_version("3.12.0") else ""
     target_part = (" --target %s" % target) if target else ""
-    cmake_build_command = "cmake --build . %s%s" % (jobs_part, target_part)
+    cmake_build_command = "%s --build . %s%s" % (cmake, jobs_part, target_part)
 
     print_and_buffer("cd %s; %s ; cd %s" % (os.path.relpath(current_cmake_cache_folder, ns3_path),
                                             cmake_build_command,
@@ -974,6 +1048,7 @@
                                   "sphinx",
                                   "manual",
                                   "models",
+                                  "ninjaTrace",
                                   "timeTraceReport",
                                   "tutorial",
                                   "contributing",
@@ -1098,8 +1173,8 @@
         if args.perf:
             debugging_software.extend([
                 check_program_installed("perf"),
-                "record", "--call-graph", "dwarf", "-a", "-e",
-                "cache-misses,branch-misses,cpu-cycles,stalled-cycles-frontend,stalled-cycles-backend,context-switches"
+                "record", "--call-graph", "dwarf", "-e",
+                "cache-misses,branch-misses,cpu-cycles,stalled-cycles-frontend,stalled-cycles-backend"
             ])
 
         # running with the visualizer?
@@ -1327,7 +1402,8 @@
     refuse_run_as_root()
 
     # Enable colorized output for CMake and GCC/Clang
-    os.environ["CLICOLOR"] = "1"
+    if os.getenv("CLICOLOR") is None:
+        os.environ["CLICOLOR"] = "1"
 
     # If pybindgen exists in the parent directory
     # (e.g. ns3-all-in-one), add it to the PYTHONPATH
@@ -1356,6 +1432,13 @@
         # We end things earlier when cleaning
         return
 
+    if args.distclean:
+        clean_cmake_artifacts(dry_run=args.dry_run)
+        clean_docs_and_tests_artifacts(dry_run=args.dry_run)
+        clean_pip_packaging_artifacts(dry_run=args.dry_run)
+        # We end things earlier when cleaning
+        return
+
     # Installation and uninstallation options become cmake targets
     if args.install:
         args.build = ['install']
@@ -1374,7 +1457,7 @@
         args.build = [args.docs] if args.docs != "all" else ["sphinx", "doxygen"]
         if "doxygen" in args.build and (not build_info["ENABLE_EXAMPLES"] or not build_info["ENABLE_TESTS"]):
             print('The "./ns3 docs doxygen" and "./ns3 docs all" commands,\n'
-                  'require examples and tests to generate introspected documentation.\n'
+                  'requires examples and tests to generate introspected documentation.\n'
                   'Try "./ns3 docs doxygen-no-build" or enable examples and tests.')
             exit(1)
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/scratch/nested-subdir/CMakeLists.txt ns-3.38/scratch/nested-subdir/CMakeLists.txt
--- ns-3.37/scratch/nested-subdir/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/scratch/nested-subdir/CMakeLists.txt	2023-03-16 20:54:23.572868300 -0700
@@ -0,0 +1,16 @@
+# Create a custom library
+add_library(
+  scratch-nested-subdir-lib
+  lib/scratch-nested-subdir-library-source.cc
+)
+
+# Link the custom library to the scratch executable
+build_exec(
+  EXECNAME scratch-nested-subdir-executable
+  SOURCE_FILES scratch-nested-subdir-executable.cc
+  LIBRARIES_TO_LINK scratch-nested-subdir-lib
+                    ${libcore}
+  # use "${ns3-libs}" "${ns3-contrib-libs}" in case you want to link to all
+  # enabled modules
+  EXECUTABLE_DIRECTORY_PATH ${CMAKE_OUTPUT_DIRECTORY}/scratch/nested-subdir
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/scratch/nested-subdir/lib/scratch-nested-subdir-library-header.h ns-3.38/scratch/nested-subdir/lib/scratch-nested-subdir-library-header.h
--- ns-3.37/scratch/nested-subdir/lib/scratch-nested-subdir-library-header.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/scratch/nested-subdir/lib/scratch-nested-subdir-library-header.h	2023-03-16 20:54:23.572868300 -0700
@@ -0,0 +1,32 @@
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+// This header does not provide much functionality but is meant to demonstrate how,
+// in a scratch subdirectory, one can create new programs that are implemented
+// in multiple files and headers.
+
+#include <string>
+
+namespace ns3
+{
+
+/**
+ * Get a message from the subdir.
+ *
+ * \return The message from the subdir
+ */
+std::string ScratchNestedSubdirGetMessage();
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/scratch/nested-subdir/lib/scratch-nested-subdir-library-source.cc ns-3.38/scratch/nested-subdir/lib/scratch-nested-subdir-library-source.cc
--- ns-3.37/scratch/nested-subdir/lib/scratch-nested-subdir-library-source.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/scratch/nested-subdir/lib/scratch-nested-subdir-library-source.cc	2023-03-16 20:54:23.572868300 -0700
@@ -0,0 +1,30 @@
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+// This file contains the implementation of the functions declared in the
+// corresponding header file.
+
+#include "scratch-nested-subdir-library-header.h"
+
+namespace ns3
+{
+
+std::string
+ScratchNestedSubdirGetMessage()
+{
+    return "Scratch Nested Subdir";
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/scratch/nested-subdir/scratch-nested-subdir-executable.cc ns-3.38/scratch/nested-subdir/scratch-nested-subdir-executable.cc
--- ns-3.37/scratch/nested-subdir/scratch-nested-subdir-executable.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/scratch/nested-subdir/scratch-nested-subdir-executable.cc	2023-03-16 20:54:23.572868300 -0700
@@ -0,0 +1,51 @@
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+// This example shows how to create new simulations that are implemented in
+// multiple files and headers. The structure of this simulation project
+// is as follows:
+//
+// scratch/
+// |  nested-subdir/
+// |  |  - scratch-nested-subdir-executable.cc        // Main simulation file
+// |  |  lib
+// |  |  |  - scratch-nested-subdir-library-header.h  // Additional header
+// |  |  |  - scratch-nested-subdir-library-source.cc // Additional header implementation
+//
+// This file contains the main() function, which calls an external function
+// defined in the "scratch-nested-subdir-library-header.h" header file and
+// implemented in "scratch-nested-subdir-library-source.cc".
+
+#include "lib/scratch-nested-subdir-library-header.h"
+
+#include "ns3/core-module.h"
+
+#include <string>
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("ScratchNestedSubdir");
+
+int
+main(int argc, char* argv[])
+{
+    std::string message = ScratchNestedSubdirGetMessage();
+    NS_LOG_UNCOND(message);
+
+    Simulator::Run();
+    Simulator::Destroy();
+
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/antenna/model/angles.cc ns-3.38/src/antenna/model/angles.cc
--- ns-3.37/src/antenna/model/angles.cc	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/antenna/model/angles.cc	2023-03-16 20:54:23.572868300 -0700
@@ -132,7 +132,7 @@
     double incl;
     std::string unit;
 
-    if (a.m_printDeg)
+    if (Angles::m_printDeg)
     {
         azim = RadiansToDegrees(a.m_azimuth);
         incl = RadiansToDegrees(a.m_inclination);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/antenna/model/angles.h ns-3.38/src/antenna/model/angles.h
--- ns-3.37/src/antenna/model/angles.h	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/antenna/model/angles.h	2023-03-16 20:54:23.572868300 -0700
@@ -120,7 +120,7 @@
     /**
      * This constructor allows to specify azimuth and inclination.
      * Inclination must be in [0, M_PI], while azimuth is
-     * automatically notmalized in [-M_PI, M_PI)
+     * automatically normalized in [-M_PI, M_PI)
      *
      * \param azimuth the azimuth angle in radians
      * \param inclination the inclination angle in radians
@@ -209,7 +209,7 @@
      *
      * Note: while an arbitrary value for the azimuth angle is valid
      * and can be wrapped in [-M_PI, M_PI), an inclination angle outside
-     * the [0, M_PI] range can be ambiguos and is thus not valid.
+     * the [0, M_PI] range can be ambiguous and is thus not valid.
      */
     void NormalizeAngles();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/antenna/model/phased-array-model.cc ns-3.38/src/antenna/model/phased-array-model.cc
--- ns-3.37/src/antenna/model/phased-array-model.cc	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/antenna/model/phased-array-model.cc	2023-03-16 20:54:23.576868300 -0700
@@ -36,7 +36,7 @@
 std::ostream&
 operator<<(std::ostream& os, const PhasedArrayModel::ComplexVector& cv)
 {
-    size_t N = cv.size();
+    size_t N = cv.GetSize();
 
     // empty
     if (N == 0)
@@ -63,7 +63,6 @@
 
 PhasedArrayModel::~PhasedArrayModel()
 {
-    m_beamformingVector.clear();
 }
 
 TypeId
@@ -85,8 +84,8 @@
 PhasedArrayModel::SetBeamformingVector(const ComplexVector& beamformingVector)
 {
     NS_LOG_FUNCTION(this << beamformingVector);
-    NS_ASSERT_MSG(beamformingVector.size() == GetNumberOfElements(),
-                  beamformingVector.size() << " != " << GetNumberOfElements());
+    NS_ASSERT_MSG(beamformingVector.GetSize() == GetNumberOfElements(),
+                  beamformingVector.GetSize() << " != " << GetNumberOfElements());
     m_beamformingVector = beamformingVector;
     m_isBfVectorValid = true;
 }
@@ -101,30 +100,17 @@
     return m_beamformingVector;
 }
 
-double
-PhasedArrayModel::ComputeNorm(const ComplexVector& vector)
-{
-    double norm = 0;
-
-    for (uint64_t i = 0; i < vector.size(); i++)
-    {
-        norm += std::norm(vector[i]);
-    }
-
-    return std::sqrt(norm);
-}
-
 PhasedArrayModel::ComplexVector
 PhasedArrayModel::GetBeamformingVector(Angles a) const
 {
     NS_LOG_FUNCTION(this << a);
 
     ComplexVector beamformingVector = GetSteeringVector(a);
-    double norm = ComputeNorm(beamformingVector);
+    double normRes = norm(beamformingVector);
 
-    for (uint64_t i = 0; i < beamformingVector.size(); i++)
+    for (size_t i = 0; i < GetNumberOfElements(); i++)
     {
-        beamformingVector[i] = std::conj(beamformingVector[i]) / norm;
+        beamformingVector[i] = std::conj(beamformingVector[i]) / normRes;
     }
 
     return beamformingVector;
@@ -133,9 +119,8 @@
 PhasedArrayModel::ComplexVector
 PhasedArrayModel::GetSteeringVector(Angles a) const
 {
-    ComplexVector steeringVector;
-    steeringVector.resize(GetNumberOfElements());
-    for (uint64_t i = 0; i < GetNumberOfElements(); i++)
+    ComplexVector steeringVector(GetNumberOfElements());
+    for (size_t i = 0; i < GetNumberOfElements(); i++)
     {
         Vector loc = GetElementLocation(i);
         double phase = -2 * M_PI *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/antenna/model/phased-array-model.h ns-3.38/src/antenna/model/phased-array-model.h
--- ns-3.37/src/antenna/model/phased-array-model.h	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/antenna/model/phased-array-model.h	2023-03-16 20:54:23.576868300 -0700
@@ -20,6 +20,7 @@
 
 #include <ns3/angles.h>
 #include <ns3/antenna-model.h>
+#include <ns3/matrix-array.h>
 #include <ns3/object.h>
 
 #include <complex>
@@ -51,8 +52,24 @@
      */
     static TypeId GetTypeId();
 
-    typedef std::vector<std::complex<double>>
-        ComplexVector; //!< type definition for complex vectors
+    //!< type definition for complex vectors
+    using ComplexVector = ComplexMatrixArray; //!< the underlying Valarray
+
+    /**
+     * \brief Computes the Frobenius norm of the complex vector
+     *
+     * \param complexVector on which to calculate Frobenius norm
+     * \return the Frobenius norm of the complex vector
+     */
+    double norm(const ComplexVector& complexVector) const
+    {
+        double norm = 0;
+        for (size_t i = 0; i < complexVector.GetSize(); i++)
+        {
+            norm += std::norm(complexVector[i]);
+        }
+        return std::sqrt(norm);
+    }
 
     /**
      * Returns the horizontal and vertical components of the antenna element field
@@ -76,7 +93,7 @@
      * Returns the number of antenna elements
      * \return the number of antenna elements
      */
-    virtual uint64_t GetNumberOfElements() const = 0;
+    virtual size_t GetNumberOfElements() const = 0;
 
     /**
      * Sets the beamforming vector to be used
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/antenna/model/three-gpp-antenna-model.h ns-3.38/src/antenna/model/three-gpp-antenna-model.h
--- ns-3.37/src/antenna/model/three-gpp-antenna-model.h	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/antenna/model/three-gpp-antenna-model.h	2023-03-16 20:54:23.576868300 -0700
@@ -25,11 +25,9 @@
 {
 
 /**
- *
  * \brief  Antenna model based on a parabolic approximation of the main lobe radiation pattern.
  *
  * This class implements the parabolic model as described in 3GPP TR 38.901 v15.0.0
- *
  */
 class ThreeGppAntennaModel : public AntennaModel
 {
@@ -65,8 +63,8 @@
     double GetSlaV() const;
 
     /**
-     * Get the naximum attenuation of the antenna element.
-     * \return the naximum attenuation in dB
+     * Get the maximum attenuation of the antenna element.
+     * \return the maximum attenuation in dB
      */
     double GetMaxAttenuation() const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/antenna/model/uniform-planar-array.cc ns-3.38/src/antenna/model/uniform-planar-array.cc
--- ns-3.37/src/antenna/model/uniform-planar-array.cc	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/antenna/model/uniform-planar-array.cc	2023-03-16 20:54:23.576868300 -0700
@@ -249,7 +249,7 @@
     return loc;
 }
 
-uint64_t
+size_t
 UniformPlanarArray::GetNumberOfElements() const
 {
     return m_numRows * m_numColumns;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/antenna/model/uniform-planar-array.h ns-3.38/src/antenna/model/uniform-planar-array.h
--- ns-3.37/src/antenna/model/uniform-planar-array.h	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/antenna/model/uniform-planar-array.h	2023-03-16 20:54:23.576868300 -0700
@@ -81,7 +81,7 @@
      * Returns the number of antenna elements
      * \return the number of antenna elements
      */
-    uint64_t GetNumberOfElements() const override;
+    size_t GetNumberOfElements() const override;
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/antenna/test/test-cosine-antenna.cc ns-3.38/src/antenna/test/test-cosine-antenna.cc
--- ns-3.37/src/antenna/test/test-cosine-antenna.cc	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/antenna/test/test-cosine-antenna.cc	2023-03-16 20:54:23.576868300 -0700
@@ -66,7 +66,7 @@
      * \param b Horizontal and Vertical Beamwidth
      * \param o Orientation
      * \param g MaxGain
-     * \param expectedGainDb Expeted antenna gain
+     * \param expectedGainDb Expected antenna gain
      * \param cond Test condition
      */
     CosineAntennaModelTestCase(Angles a,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/antenna/test/test-degrees-radians.cc ns-3.38/src/antenna/test/test-degrees-radians.cc
--- ns-3.37/src/antenna/test/test-degrees-radians.cc	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/antenna/test/test-degrees-radians.cc	2023-03-16 20:54:23.576868300 -0700
@@ -129,7 +129,7 @@
 /**
  * \ingroup tests
  *
- * \brief TestSuite: degree to radians (and viceversa) conversions
+ * \brief TestSuite: degree to radians (and vice-versa) conversions
  */
 class DegreesRadiansTestSuite : public TestSuite
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/antenna/test/test-isotropic-antenna.cc ns-3.38/src/antenna/test/test-isotropic-antenna.cc
--- ns-3.37/src/antenna/test/test-isotropic-antenna.cc	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/antenna/test/test-isotropic-antenna.cc	2023-03-16 20:54:23.576868300 -0700
@@ -45,7 +45,7 @@
     /**
      * Constructor
      * \param a Antenna angle
-     * \param expectedGainDb Expeted antenna gain
+     * \param expectedGainDb Expected antenna gain
      */
     IsotropicAntennaModelTestCase(Angles a, double expectedGainDb);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/antenna/test/test-parabolic-antenna.cc ns-3.38/src/antenna/test/test-parabolic-antenna.cc
--- ns-3.37/src/antenna/test/test-parabolic-antenna.cc	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/antenna/test/test-parabolic-antenna.cc	2023-03-16 20:54:23.576868300 -0700
@@ -66,7 +66,7 @@
      * \param b Beamwidth
      * \param o Orientation
      * \param g MaxGain
-     * \param expectedGainDb Expeted antenna gain
+     * \param expectedGainDb Expected antenna gain
      * \param cond Test condition
      */
     ParabolicAntennaModelTestCase(Angles a,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/antenna/test/test-uniform-planar-array.cc ns-3.38/src/antenna/test/test-uniform-planar-array.cc
--- ns-3.37/src/antenna/test/test-uniform-planar-array.cc	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/antenna/test/test-uniform-planar-array.cc	2023-03-16 20:54:23.576868300 -0700
@@ -153,14 +153,16 @@
 {
     // compute gain
     PhasedArrayModel::ComplexVector sv = a->GetSteeringVector(m_direction);
-    NS_TEST_EXPECT_MSG_EQ(sv.size(), a->GetNumberOfElements(), "steering vector of wrong size");
+    NS_TEST_EXPECT_MSG_EQ(sv.GetSize(), a->GetNumberOfElements(), "steering vector of wrong size");
     PhasedArrayModel::ComplexVector bf = a->GetBeamformingVector(m_direction);
-    NS_TEST_EXPECT_MSG_EQ(bf.size(), a->GetNumberOfElements(), "beamforming vector of wrong size");
+    NS_TEST_EXPECT_MSG_EQ(bf.GetSize(),
+                          a->GetNumberOfElements(),
+                          "beamforming vector of wrong size");
     std::pair<double, double> fp = a->GetElementFieldPattern(m_direction);
 
     // scalar product dot (sv, bf)
     std::complex<double> prod{0};
-    for (size_t i = 0; i < sv.size(); i++)
+    for (size_t i = 0; i < sv.GetSize(); i++)
     {
         prod += sv[i] * bf[i];
     }
